
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="fr">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Gradient &#8212; Documentation Segmentation Image 4.0</title>
    <link rel="stylesheet" href="../_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../" src="../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Recherche" href="../search.html" /> 
  </head><body>
<div style="background-color: white; text-align: left; padding: 10px 10px 15px 15px">
  <a href="../index.html">
  <img src="../_static/logo.png" border="0" alt="Segmentation Image"/>
  </a>
</div>

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Code du module</a> &#187;</li> 
      </ul>
    </div>

      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Recherche rapide</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Code source de Gradient</h1><div class="highlight"><pre>
<span></span><span class="c1">#####################################</span>
<span class="c1"># Cecile Prouteau</span>
<span class="c1"># CTES Projet Math-Info</span>
<span class="c1"># Projet segmentation d&#39;image</span>
<span class="c1"># 27/04/2019</span>
<span class="c1"># Classe Gradient Version 0.1</span>
<span class="c1">#####################################</span>

<span class="c1">### IMPORTATION DES BIBLIOTHEQUES</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">math</span>

<span class="c1">### IMPORTATION DES CLASSES</span>
<span class="kn">from</span> <span class="nn">Image</span> <span class="k">import</span> <span class="n">Image</span>
<span class="kn">from</span> <span class="nn">Pixel</span> <span class="k">import</span> <span class="n">Pixel</span>

<span class="c1">### DEBUT de la classe Partage_eaux</span>

<div class="viewcode-block" id="Gradient"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient">[docs]</a><span class="k">class</span> <span class="nc">Gradient</span><span class="p">:</span>
    
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    </span>
<span class="sd">    **AUTRES CLASSES IMPORTEES**</span>
<span class="sd">    </span>
<span class="sd">    * Image</span>
<span class="sd">    * Pixel</span>
<span class="sd">    * numpy</span>
<span class="sd">    * math</span>
<span class="sd">   </span>
<span class="sd">    </span>
<span class="sd">    **LES METHODES**</span>
<span class="sd">     </span>
<span class="sd">    </span>
<span class="sd">    &quot;&quot;&quot;</span>
    
<div class="viewcode-block" id="Gradient.__init__"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">image</span><span class="p">,</span><span class="n">gamma</span><span class="p">):</span>
        
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        Constructeur d&#39;un objet Gradient à partir de l&#39;image &#39;image&#39; selon l&#39;élément structurant &#39;gamma&#39;.</span>

<span class="sd">        :param self: Objet Gradient </span>
<span class="sd">        :type self: Gradient</span>
<span class="sd">        </span>
<span class="sd">        :param image: objet Image est un tableau numpy d&#39;une image codée sur une couche en niveaux de gris</span>
<span class="sd">        :type image: Image </span>
<span class="sd">        </span>
<span class="sd">        :param gamma: liste correspondante à l&#39;élément structurant (Gamma_4 ou Gamma_8)</span>
<span class="sd">        :type gamma: List </span>
<span class="sd">        </span>
<span class="sd">        :return: Objet Gradient </span>
<span class="sd">        :rtype: Gradient </span>
<span class="sd">        </span>
<span class="sd">        Liste des champs de la classe</span>
<span class="sd">        </span>
<span class="sd">        * self.largeur largeur de l&#39;image</span>
<span class="sd">        * self.hauteur hauteur de l&#39;image</span>
<span class="sd">        * self.nb_pixels nombre de pixels de l&#39;image</span>
<span class="sd">        </span>
<span class="sd">        * self.image = image au format Numpy</span>
<span class="sd">        * self.gamma = liste correspondante à l&#39;élément structurant</span>
<span class="sd">        * self.tab image du gradient</span>
<span class="sd">        </span>
<span class="sd">        Pour les lignes et les colonnes je me place du point de vue de l&#39;image. </span>
<span class="sd">        Dans le tableau numpy, les coordonnées sont inversées.</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="c1">#self.image=image.image_np_gray</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">largeur</span> <span class="o">=</span> <span class="n">image</span><span class="o">.</span><span class="n">largeur</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span> <span class="o">=</span> <span class="n">image</span><span class="o">.</span><span class="n">hauteur</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">nb_pixels</span><span class="o">=</span><span class="n">image</span><span class="o">.</span><span class="n">largeur</span><span class="o">*</span><span class="n">image</span><span class="o">.</span><span class="n">hauteur</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">image</span><span class="o">=</span><span class="n">image</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">gamma</span><span class="o">=</span><span class="n">gamma</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">tab</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">cree_gradient_image</span><span class="p">(</span><span class="n">image</span><span class="p">)</span></div>


    <span class="c1">## FONCTIONS DE CALCUL DE GRADIENT</span>
    
<div class="viewcode-block" id="Gradient.cree_gradient_image"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.cree_gradient_image">[docs]</a>    <span class="k">def</span> <span class="nf">cree_gradient_image</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">image</span><span class="p">):</span>
        
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        Création du tableau modélisant le gradient de l&#39;image &#39;image&#39; à mettre dans le champ tab d&#39;un objet Gradient</span>

<span class="sd">        :param self: Objet Gradient </span>
<span class="sd">        :type self: Gradient</span>
<span class="sd">        </span>
<span class="sd">        :param image: objet Image est un tableau numpy d&#39;une image codée sur une couche en niveaux de gris</span>
<span class="sd">        :type image: Image </span>
<span class="sd">        </span>
<span class="sd">        :return: tableau des pixels correspondant à l&#39;image avec comme valeur celle du gradient.</span>
<span class="sd">        :rtype: List</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="n">tableau</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="o">*</span><span class="p">[</span><span class="kc">None</span><span class="p">]</span>
        <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">):</span>
            <span class="n">tableau</span><span class="p">[</span><span class="n">x</span><span class="p">]</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span><span class="o">*</span><span class="p">[</span><span class="kc">None</span><span class="p">]</span>
        
        <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span><span class="p">):</span>
            <span class="k">for</span> <span class="n">y</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span><span class="p">):</span>
                <span class="n">L</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">calcule_liste_coord_pixels_voisins_depuis_coord</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">)</span>
                <span class="n">tableau</span><span class="p">[</span><span class="n">x</span><span class="p">][</span><span class="n">y</span><span class="p">]</span><span class="o">=</span><span class="n">Pixel</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="bp">self</span><span class="o">.</span><span class="n">calcule_valeur_gradient_pixel_de_liste_voisins</span><span class="p">(</span><span class="n">L</span><span class="p">,</span><span class="n">image</span><span class="p">))</span>
                <span class="n">tableau</span><span class="p">[</span><span class="n">x</span><span class="p">][</span><span class="n">y</span><span class="p">]</span><span class="o">.</span><span class="n">maj_liste_coord_voisins</span><span class="p">(</span><span class="n">L</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">tableau</span></div>
        
<div class="viewcode-block" id="Gradient.calcule_valeur_gradient_pixel_de_liste_voisins"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.calcule_valeur_gradient_pixel_de_liste_voisins">[docs]</a>    <span class="k">def</span> <span class="nf">calcule_valeur_gradient_pixel_de_liste_voisins</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">L</span><span class="p">,</span><span class="n">image</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Fonction qui calcule la valeur du gradient d&#39;un pixel à partir de la liste des coordonnées de ses voisins</span>
<span class="sd">        </span>
<span class="sd">        :param self: Gradient</span>
<span class="sd">        :type self: Objet Gradient</span>
<span class="sd">        </span>
<span class="sd">        :param L: Liste des coordonnées des voisins pour calcul du gradient</span>
<span class="sd">        :type L: List</span>
<span class="sd">        </span>
<span class="sd">        :return: gradient d&#39;un pixel</span>
<span class="sd">        :rtype: int</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>    
        
        <span class="nb">min</span><span class="o">=</span><span class="mi">255</span>
        <span class="nb">max</span><span class="o">=</span><span class="mi">0</span>
        <span class="k">for</span> <span class="n">coord</span> <span class="ow">in</span> <span class="n">L</span><span class="p">:</span>
            <span class="n">valeur</span><span class="o">=</span><span class="n">image</span><span class="o">.</span><span class="n">couleur_entier_8bits</span><span class="p">(</span><span class="n">coord</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span><span class="n">coord</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
            <span class="k">if</span> <span class="n">valeur</span><span class="o">&lt;</span><span class="nb">min</span><span class="p">:</span>
                <span class="nb">min</span><span class="o">=</span><span class="n">valeur</span>
            <span class="k">if</span> <span class="n">valeur</span><span class="o">&gt;</span><span class="nb">max</span><span class="p">:</span>
                <span class="nb">max</span><span class="o">=</span><span class="n">valeur</span>

        <span class="k">return</span> <span class="nb">max</span><span class="o">-</span><span class="nb">min</span>    </div>
    
    
        
<div class="viewcode-block" id="Gradient.calcule_valeur_gradient_pixel_de_coord"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.calcule_valeur_gradient_pixel_de_coord">[docs]</a>    <span class="k">def</span> <span class="nf">calcule_valeur_gradient_pixel_de_coord</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">,</span><span class="n">image</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Fonction qui calcule la valeur du gradient d&#39;un pixel d&#39;une image à partir de ses coodonnées</span>
<span class="sd">        </span>
<span class="sd">        :param self: Gradient</span>
<span class="sd">        :type self: Objet Gradient</span>
<span class="sd">        </span>
<span class="sd">        :param x: abscisse du pixel pour lequel on cherche le gradient</span>
<span class="sd">        :type x: int</span>
<span class="sd">        </span>
<span class="sd">        :param y: ordonnée du pixel pour lequel on cherche le gradient</span>
<span class="sd">        :type y: int </span>
<span class="sd">        </span>
<span class="sd">        :return: gradient d&#39;un pixel</span>
<span class="sd">        :rtype: int</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>    
        
        <span class="n">L</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">calcule_liste_coord_pixels_voisins_depuis_coord</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">)</span>
        <span class="nb">min</span><span class="o">=</span><span class="mi">255</span>
        <span class="nb">max</span><span class="o">=</span><span class="mi">0</span>
        <span class="k">for</span> <span class="n">coord</span> <span class="ow">in</span> <span class="n">L</span><span class="p">:</span>
            <span class="n">valeur</span><span class="o">=</span><span class="n">image</span><span class="o">.</span><span class="n">couleur_entier_8bits</span><span class="p">(</span><span class="n">coord</span><span class="p">[</span><span class="mi">1</span><span class="p">],</span><span class="n">coord</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
            <span class="k">if</span> <span class="n">valeur</span><span class="o">&lt;</span><span class="nb">min</span><span class="p">:</span>
                <span class="nb">min</span><span class="o">=</span><span class="n">valeur</span>
            <span class="k">if</span> <span class="n">valeur</span><span class="o">&gt;</span><span class="nb">max</span><span class="p">:</span>
                <span class="nb">max</span><span class="o">=</span><span class="n">valeur</span>
        <span class="k">return</span> <span class="nb">max</span><span class="o">-</span><span class="nb">min</span></div>
        
    
<div class="viewcode-block" id="Gradient.calcule_valeur_gradient_pixel"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.calcule_valeur_gradient_pixel">[docs]</a>    <span class="k">def</span> <span class="nf">calcule_valeur_gradient_pixel</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">pix</span><span class="p">,</span><span class="n">image</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Fonction qui calcule la valeur du gradient du pixel pix de l&#39;image selon l&#39;élément structurant self.gamma</span>
<span class="sd">        </span>
<span class="sd">        :param self: Gradient</span>
<span class="sd">        :type self: Objet Gradient</span>
<span class="sd">        </span>
<span class="sd">        :param pix: pixel pour lequel on cherche les voisins</span>
<span class="sd">        :type pix: objet Pixel  </span>
<span class="sd">        </span>
<span class="sd">        :return: liste des pixels voisins de pix </span>
<span class="sd">        :rtype: List</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>    
        
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">calcule_valeur_gradient_pixel_de_coord</span><span class="p">(</span><span class="n">pix</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="n">pix</span><span class="o">.</span><span class="n">y</span><span class="p">,</span><span class="n">image</span><span class="p">)</span>  </div>
            


    
    <span class="c1">## FONCTIONS DE RECHERCHE DE VOISINS</span>
    
<div class="viewcode-block" id="Gradient.calcule_liste_coord_pixels_voisins_depuis_coord"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.calcule_liste_coord_pixels_voisins_depuis_coord">[docs]</a>    <span class="k">def</span> <span class="nf">calcule_liste_coord_pixels_voisins_depuis_coord</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procédure qui calcule la liste des coordonnées des pixels voisins du pixel de coordonnées (x,y) selon l&#39;élément structurant self.gamma</span>
<span class="sd">        </span>
<span class="sd">        :param self: Gradient</span>
<span class="sd">        :type self: Objet Gradient</span>
<span class="sd">        </span>
<span class="sd">        :param x: abscisse du pixel pour lequel on cherche les voisins</span>
<span class="sd">        :type x: int</span>
<span class="sd">        </span>
<span class="sd">        :param y: ordonnée du pixel pour lequel on cherche les voisins</span>
<span class="sd">        :type y: int</span>
<span class="sd">        </span>
<span class="sd">        :return: liste des coordonnées des pixels voisins du pixel de coordonnées (x,y) selon l&#39;élément structurant self.gamma</span>
<span class="sd">        :rtype: List</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># initialisation de la liste des coordonnées des pixels voisins</span>
        <span class="n">L</span><span class="o">=</span><span class="p">[]</span>
        <span class="c1"># remplissage de la liste des coordonnées en tenant compte des bords de l&#39;image</span>
        <span class="k">for</span> <span class="n">element</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">gamma</span><span class="p">:</span>
            <span class="n">X</span><span class="o">=</span><span class="n">x</span><span class="o">+</span><span class="n">element</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">Y</span><span class="o">=</span><span class="n">y</span><span class="o">+</span><span class="n">element</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
            <span class="k">if</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">X</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">largeur</span> <span class="ow">and</span> <span class="mi">0</span><span class="o">&lt;=</span><span class="n">Y</span><span class="o">&lt;</span><span class="bp">self</span><span class="o">.</span><span class="n">hauteur</span><span class="p">:</span>
                <span class="n">L</span><span class="o">.</span><span class="n">append</span><span class="p">([</span><span class="n">X</span><span class="p">,</span><span class="n">Y</span><span class="p">])</span>
        <span class="k">return</span> <span class="n">L</span></div>

    
<div class="viewcode-block" id="Gradient.calcule_liste_pixels_voisins_depuis_coord"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.calcule_liste_pixels_voisins_depuis_coord">[docs]</a>    <span class="k">def</span> <span class="nf">calcule_liste_pixels_voisins_depuis_coord</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Fonction qui calcule la liste des pixels voisins du pixel de coordonnées (x,y) selon l&#39;élément structurant self.gamma</span>
<span class="sd">        </span>
<span class="sd">        :param self: Gradient</span>
<span class="sd">        :type self: Objet Gradient</span>
<span class="sd">        </span>
<span class="sd">        :param x: abscisse du pixel pour lequel on cherche les voisins</span>
<span class="sd">        :type x: int</span>
<span class="sd">        </span>
<span class="sd">        :param y: ordonnée du pixel pour lequel on cherche les voisins</span>
<span class="sd">        :type y: int</span>
<span class="sd">        </span>
<span class="sd">        :return: liste des pixels voisins de pix selon l&#39;élément structurant self.gamma</span>
<span class="sd">        :rtype: List</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># initialisation de la liste des pixels voisins</span>
        <span class="n">L_pixels</span><span class="o">=</span><span class="p">[]</span>
        <span class="c1"># calcul de la liste des coordonnées des pixels voisins</span>
        <span class="n">L_coord</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">calcule_liste_coord_pixels_voisins_depuis_coord</span><span class="p">(</span><span class="n">x</span><span class="p">,</span><span class="n">y</span><span class="p">)</span>
        <span class="c1"># remplissage de la liste des pixels voisins</span>
        <span class="k">for</span> <span class="n">coord</span> <span class="ow">in</span> <span class="n">L_coord</span><span class="p">:</span>
            <span class="n">L_pixels</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tab</span><span class="p">[</span><span class="n">coord</span><span class="p">[</span><span class="mi">0</span><span class="p">]][</span><span class="n">coord</span><span class="p">[</span><span class="mi">1</span><span class="p">]])</span>
        <span class="k">return</span> <span class="n">L_pixels</span></div>
        
<div class="viewcode-block" id="Gradient.calcule_liste_pixels_voisins_depuis_pixel"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.calcule_liste_pixels_voisins_depuis_pixel">[docs]</a>    <span class="k">def</span> <span class="nf">calcule_liste_pixels_voisins_depuis_pixel</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">pix</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procédure qui calcule la liste des pixels voisins du pixel pix selon l&#39;élément structurant self.gamma</span>
<span class="sd">        </span>
<span class="sd">        :param self: Gradient</span>
<span class="sd">        :type self: Objet Gradient</span>
<span class="sd">        </span>
<span class="sd">        :param pix: pixel pour lequel on cherche les voisins</span>
<span class="sd">        :type pix: objet Pixel  </span>
<span class="sd">        </span>
<span class="sd">        :return: liste des pixels voisins de pix selon self.gamma</span>
<span class="sd">        :rtype: List</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">calcule_liste_pixels_voisins_depuis_coord</span><span class="p">(</span><span class="n">pix</span><span class="o">.</span><span class="n">x</span><span class="p">,</span><span class="n">pix</span><span class="o">.</span><span class="n">y</span><span class="p">)</span></div>

<div class="viewcode-block" id="Gradient.affiche"><a class="viewcode-back" href="../tec_doc.html#Gradient.Gradient.affiche">[docs]</a>    <span class="k">def</span> <span class="nf">affiche</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Procédure qui affiche le gradient, ligne de pixel par ligne de pixel</span>
<span class="sd">        </span>
<span class="sd">        :param self: Gradient</span>
<span class="sd">        :type self: Objet Gradient</span>
<span class="sd">        </span>
<span class="sd">        :return: None</span>
<span class="sd">        :rtype: None object</span>
<span class="sd">        </span>
<span class="sd">        &quot;&quot;&quot;</span>
        
        <span class="k">for</span> <span class="n">ligne</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">tab</span><span class="p">:</span>
            <span class="k">for</span> <span class="n">pix</span> <span class="ow">in</span> <span class="n">ligne</span><span class="p">:</span>
                <span class="n">pix</span><span class="o">.</span><span class="n">affiche_pixel</span><span class="p">()</span></div></div>
        

</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="Index général"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Index des modules Python"
             >modules</a> |</li>
<li><a href="../index.html">Segmentation Image home</a>| </li>
<li><a href="../contents.html">Documentation </a> &raquo;</li>

          <li class="nav-item nav-item-1"><a href="index.html" >Code du module</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, Cecile Prouteau.
      Créé avec <a href="http://sphinx-doc.org/">Sphinx</a> 1.7.9.
    </div>
  </body>
</html>